diff --git Config.kmk Config.kmk
index 26405c1..7fc412a 100644
--- Config.kmk
+++ Config.kmk
@@ -440,7 +440,7 @@ VBOX_WITH_VMSVGA = 1
 # Enable Host Guest Shared Memory Interface.
 VBOX_WITH_HGSMI = 1
 # Enable Video 2D Acceleration.
-if1of ($(KBUILD_TARGET), darwin linux win freebsd)
+if1of ($(KBUILD_TARGET), darwin linux win freebsd netbsd)
  VBOX_WITH_VIDEOHWACCEL = 1
 endif
 # Enable Wddm Video driver for Vista+ guests.
@@ -618,13 +618,13 @@ VBOX_WITH_GUEST_PROPS_RDONLY_GUEST =
 # Compile the host channel
 VBOX_WITH_HOST_CHANNEL = 1
 # Enable the guest control service.
-if1of ($(KBUILD_TARGET), darwin freebsd linux solaris win)
+if1of ($(KBUILD_TARGET), darwin freebsd linux netbsd solaris win)
  VBOX_WITH_GUEST_CONTROL = 1
 endif
 # Enable ballooning
 VBOX_WITH_MEMBALLOON = 1
 # Enable crOpenGL service
-if1of ($(KBUILD_TARGET), darwin freebsd linux solaris win)
+if1of ($(KBUILD_TARGET), darwin freebsd linux netbsd solaris win)
  VBOX_WITH_CROGL = 1
 endif
 # enable new wined3d code
@@ -632,7 +632,7 @@ VBOX_WITH_NEW_WINE = 1
 # Enable S3 support (requires libcurl)
 VBOX_WITH_S3 = 1
 # Enable Host=>Guest Drag'n'Drop
-if1of ($(KBUILD_TARGET), darwin linux solaris win)
+if1of ($(KBUILD_TARGET), darwin netbsd linux solaris win)
  VBOX_WITH_DRAG_AND_DROP = 1
  # Guest=>Host drag'n'drop doesn't work
  #VBOX_WITH_DRAG_AND_DROP_GH = 1
@@ -746,6 +746,8 @@ ifdef VBOX_WITH_HARDENING
   VBOX_PATH_APP_PRIVATE      = /Applications/VirtualBox.app/Contents/MacOS
  else ifeq ($(KBUILD_TARGET),freebsd)
   VBOX_PATH_APP_PRIVATE      = /usr/local/lib/virtualbox
+ else ifeq ($(KBUILD_TARGET),netbsd)
+  VBOX_PATH_APP_PRIVATE      = /usr/local/lib/virtualbox
  else ifeq ($(KBUILD_TARGET),haiku)
   VBOX_PATH_APP_PRIVATE      = /boot/apps/VirtualBox
  endif
@@ -893,7 +895,7 @@ ifeq ($(KBUILD_TARGET),darwin)
  VBOX_WITH_VBOXSDL=
 endif
 
-ifeq ($(KBUILD_TARGET),freebsd)
+if1of ($(KBUILD_TARGET),freebsd netbsd)
  VBOX_WITH_DOCS=
 endif
 
@@ -1861,7 +1863,7 @@ VBOX_DEF_2_LAZY_LOAD ?= $(PATH_OBJ)/VBoxDef2LazyLoad/VBoxDef2LazyLoad$(HOSTSUFF_
 # GNU tar if present.
 if1of ($(KBUILD_TARGET), linux os2 win)
  VBOX_GTAR ?= tar
-else if1of ($(KBUILD_TARGET), freebsd solaris)
+else if1of ($(KBUILD_TARGET), freebsd netbsd solaris)
  VBOX_GTAR ?= gtar
 endif
 
@@ -2191,7 +2193,7 @@ ifdef VBOX_WITH_CROGL
   VBOX_LIB_OGL_HOSTCRUTIL = $(PATH_STAGE_BIN)/VBoxOGLhostcrutil$(VBOX_SUFF_DLL)
  endif
 
- if1of ($(KBUILD_TARGET), freebsd linux solaris)
+ if1of ($(KBUILD_TARGET), freebsd linux netbsd solaris)
  # VBOX_PATH_MESA_SOURCE = $(PATH_ROOT)/src/libs/mesa-7.2
   VBOX_PATH_MESA_SOURCE = $(VBOX_PATH_X11_ROOT)/mesa-7.2
   VBOX_MESA_INCS = \
@@ -3124,7 +3126,7 @@ ifdef VBOX_WITH_RAW_MODE
    ## @todo WTF doesn't the globals work? Debug info is supposed to be split everywhere. GRR
    TEMPLATE_VBoxRc_LD_DEBUG          = split
   endif
-  ifn1of ($(KBUILD_TARGET), solaris freebsd)
+  ifn1of ($(KBUILD_TARGET), solaris freebsd netbsd)
    TEMPLATE_VBoxRc_LIBS               = \
 	$(VBOX_GCC32_LIBGCC) # instricts
   endif
@@ -3269,7 +3271,7 @@ else
  ## @todo WTF doesn't the globals work? Debug info is supposed to be split everywhere. GRR
  TEMPLATE_VBoxR0_LD_DEBUG           = split
 endif
-ifn1of ($(KBUILD_TARGET),solaris freebsd)
+ifn1of ($(KBUILD_TARGET),solaris freebsd netbsd)
  TEMPLATE_VBoxR0_LIBS               = \
 	$(VBOX_GCC_LIBGCC) # instricts
 endif
@@ -3544,6 +3546,65 @@ endef
 
 endif # FreeBSD
 
+ifeq ($(KBUILD_TARGET),netbsd)
+
+## The location of the NetBSD kernel headers.
+VBOX_NETBSD_SRC ?= /usr/src/sys
+
+ifeq ($(KBUILD_TARGET_ARCH),amd64)
+VBOX_NETBSD_MACHINE_SRC=$(VBOX_NETBSD_SRC)/arch/amd64
+else
+VBOX_NETBSD_MACHINE_SRC=$(VBOX_NETBSD_SRC)/arch/i386
+endif
+
+TEMPLATE_VBOXR0DRV_TOOL                = $(VBOX_GCC_TOOL)
+TEMPLATE_VBOXR0DRV_DEFS               += _KERNEL _MODULE
+TEMPLATE_VBOXR0DRV_INCS                = \
+	$(VBOX_NETBSD_SRC) \
+	$(VBOX_NETBSD_SRC)/../common/include \
+	$(PATH_OBJ)/netbsd/include
+
+TEMPLATE_VBOXR0DRV_CFLAGS              =  \
+	$(VBOX_GCC_WARN) -Wpointer-arith -Winline $(VBOX_GCC_Wno-pointer-sign) \
+	$(VBOX_GCC_fdiagnostics-show-option) \
+	-Wstrict-prototypes -Wmissing-prototypes -Wstrict-prototypes \
+	-Wimplicit-function-declaration -Werror-implicit-function-declaration \
+	-O2 -ffreestanding -fno-strict-aliasing -fno-common -finline-limit=8000 \
+	$(VBOX_GCC_fno-stack-protector) $(VBOX_GCC_R0_OPT) $(VBOX_GCC_R0_FP) \
+	-nostdinc -std=gnu99 -msoft-float
+TEMPLATE_VBOXR0DRV_CFLAGS.x86          = -m32 -mno-align-long-strings \
+    -mpreferred-stack-boundary=2 -mno-mmx -mno-sse -mno-avx \
+    -mno-fp-ret-in-387
+TEMPLATE_VBOXR0DRV_CFLAGS.amd64        = -m64 --param inline-unit-growth=100 \
+    --param large-function-growth=1000 -fno-omit-frame-pointer \
+    -mcmodel=kernel -mno-red-zone -mno-sse -mno-mmx -mno-avx \
+	-fno-asynchronous-unwind-tables -mno-fp-ret-in-387
+TEMPLATE_VBOXR0DRV_CXXFLAGS            = -fno-exceptions -fno-rtti \
+	$(VBOX_GCC_WARN) -Wpointer-arith -Winline \
+	-O2 -fno-strict-aliasing -fno-common -finline-limit=8000 \
+	$(VBOX_GCC_fno-stack-protector) $(VBOX_GCC_R0_OPT) $(VBOX_GCC_R0_FP) \
+	-nostdinc -msoft-float
+TEMPLATE_VBOXR0DRV_CXXFLAGS.x86        = $(TEMPLATE_VBOXR0DRV_CFLAGS.x86)
+TEMPLATE_VBOXR0DRV_CXXFLAGS.amd64      = $(TEMPLATE_VBOXR0DRV_CFLAGS.amd64)
+TEMPLATE_VBOXR0DRV_SYSSUFF             = .kmod
+TEMPLATE_VBOXR0DRV_LDFLAGS             = -d --warn-common
+TEMPLATE_VBOXR0DRV_LDFLAGS.x86         = -m elf_i386
+TEMPLATE_VBOXR0DRV_LDFLAGS.amd64       = -m elf_x86_64
+
+TEMPLATE_VBOXR0DRV_ORDERDEPS = \
+	$(PATH_OBJ)/netbsd/include/machine/cdefs.h \
+	$(PATH_OBJ)/netbsd/include/x86/cpu.h
+
+$$(PATH_OBJ)/netbsd/include/machine/cdefs.h: $(VBOX_NETBSD_MACHINE_SRC)/include/cdefs.h
+	$(QUIET)$(MKDIR) -p $(@D)
+	$(QUIET)cp $(VBOX_NETBSD_MACHINE_SRC)/include/*.h $(@D)/
+
+$$(PATH_OBJ)/netbsd/include/x86/cpu.h: $(VBOX_NETBSD_SRC)/arch/x86/include/cpu.h
+	$(QUIET)$(MKDIR) -p $(@D)/x86
+	$(QUIET)cp $(VBOX_NETBSD_SRC)/arch/x86/include/*.h $(@D)/
+
+endif # NetBSD
+
 ifeq ($(KBUILD_TARGET),haiku)
 ## The Haiku include directories
 VBOX_HAIKU_SYS_INCS ?= /boot/develop/headers/os/kernel /boot/develop/headers/os/drivers
@@ -3728,7 +3789,7 @@ TEMPLATE_VBOXR3EXE_LIBPATH            += \
 TEMPLATE_VBOXR3EXE_CFLAGS             += -fno-pic
 TEMPLATE_VBOXR3EXE_CXXFLAGS           += -fno-pic
 TEMPLATE_VBOXR3EXE_LDFLAGS            += -fno-pic
- else if1of ($(KBUILD_TARGET), freebsd netbsd openbsd)
+ else if1of ($(KBUILD_TARGET), freebsd openbsd)
 TEMPLATE_VBOXR3EXE_TOOL                = GXX3
 TEMPLATE_VBOXR3EXE_LIBS                = pthread
 TEMPLATE_VBOXR3EXE_INCS               += \
@@ -3739,6 +3800,15 @@ TEMPLATE_VBOXR3EXE_LIBPATH            += \
 	/usr/lib \
 	/usr/X11R6/lib \
 	/usr/local/lib
+ else if1of ($(KBUILD_TARGET), netbsd)
+TEMPLATE_VBOXR3EXE_TOOL                = GXX3
+TEMPLATE_VBOXR3EXE_LIBS                = pthread
+TEMPLATE_VBOXR3EXE_INCS               += \
+	/usr/include \
+	/usr/X11R7/include
+TEMPLATE_VBOXR3EXE_LIBPATH            += \
+	/usr/lib \
+	/usr/X11R7/lib
  else ifeq ($(KBUILD_TARGET),solaris)
 TEMPLATE_VBOXR3EXE_TOOL                = GXX3PLAIN
 TEMPLATE_VBOXR3EXE_DEFS               += LIBICONV_PLUG _REENTRANT # Avoid the GNU libiconv, for now at least.
@@ -3810,7 +3880,7 @@ TEMPLATE_VBoxR3Dll-x86_DEFS           = $(filter-out HC_ARCH_BITS%,$(TEMPLATE_VB
 #
 TEMPLATE_VBoxR3DllNoPic                    = VBox ring-3 SO/DLLs without PIC, without warnings.
 TEMPLATE_VBoxR3DllNoPic_EXTENDS            = VBOXR3
-if1of ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH), linux.x86 freebsd.x86)
+if1of ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH), linux.x86 freebsd.x86 netbsd.x86)
  TEMPLATE_VBoxR3DllNoPic_DEFS              = $(TEMPLATE_VBOXR3EXE_DEFS)
  TEMPLATE_VBoxR3DllNoPic_CFLAGS            = $(TEMPLATE_VBOXR3EXE_CFLAGS)   $(VBOX_GCC_WERR)
  TEMPLATE_VBoxR3DllNoPic_CXXFLAGS          = $(TEMPLATE_VBOXR3EXE_CXXFLAGS) $(VBOX_GCC_WERR)
@@ -3841,7 +3911,7 @@ TEMPLATE_VBoxR3DllNoPic-x86_DEFS           = $(filter-out HC_ARCH_BITS%,$(TEMPLA
 #
 TEMPLATE_VBoxR3DllWarnNoPic                = VBox ring-3 SO/DLLs without PIC, with warnings.
 TEMPLATE_VBoxR3DllWarnNoPic_EXTENDS        = VBOXR3
-if1of ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH), linux.x86 freebsd.x86)
+if1of ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH), linux.x86 freebsd.x86 netbsd.x86)
  TEMPLATE_VBoxR3DllWarnNoPic_DEFS          = $(TEMPLATE_VBOXR3EXE_DEFS)
  TEMPLATE_VBoxR3DllWarnNoPic_CFLAGS        = $(TEMPLATE_VBOXR3EXE_CFLAGS)
  TEMPLATE_VBoxR3DllWarnNoPic_CXXFLAGS      = $(TEMPLATE_VBOXR3EXE_CXXFLAGS)
@@ -4380,7 +4450,7 @@ TEMPLATE_VBOXMAINEXE_LIBS                = $(LIB_RUNTIME)
  else ifeq ($(KBUILD_TARGET),haiku)
 TEMPLATE_VBOXMAINEXE_TOOL                = GXX3
 TEMPLATE_VBOXMAINEXE_LIBS                = $(LIB_RUNTIME) network stdc++ supc++
- else if1of ($(KBUILD_TARGET), freebsd netbsd openbsd)
+ else if1of ($(KBUILD_TARGET), freebsd openbsd)
 TEMPLATE_VBOXMAINEXE_TOOL                = GXX3
 TEMPLATE_VBOXMAINEXE_LIBS                = $(LIB_RUNTIME)
 TEMPLATE_VBOXMAINEXE_INCS               += \
@@ -4391,6 +4461,17 @@ TEMPLATE_VBOXMAINEXE_LIBPATH            += \
 	/usr/lib \
 	/usr/X11R6/lib \
 	/usr/local/lib
+ else if1of ($(KBUILD_TARGET), netbsd)
+TEMPLATE_VBOXMAINEXE_TOOL                = GXX3
+TEMPLATE_VBOXMAINEXE_LIBS                = $(LIB_RUNTIME)
+TEMPLATE_VBOXMAINEXE_INCS               += \
+	/usr/include \
+	/usr/X11R7/include \
+	/usr/local/include
+TEMPLATE_VBOXMAINEXE_LIBPATH            += \
+	/usr/lib \
+	/usr/X11R7/lib \
+	/usr/local/lib
 else ifeq ($(KBUILD_TARGET),solaris)
 TEMPLATE_VBOXMAINEXE_TOOL                = GXX3PLAIN
 TEMPLATE_VBOXMAINEXE_DEFS               += _REENTRANT
@@ -5046,7 +5127,7 @@ TEMPLATE_VBoxBldProg_TOOL                = GXX3
 TEMPLATE_VBoxBldProg_LIBS                = network iconv
 TEMPLATE_VBoxBldProg_LIBPATH            += \
 	/boot/common/lib
- else if1of ($(KBUILD_HOST), freebsd netbsd openbsd)
+ else if1of ($(KBUILD_HOST), freebsd openbsd)
 TEMPLATE_VBoxBldProg_TOOL                = GXX3
 TEMPLATE_VBoxBldProg_LIBS                = pthread
 TEMPLATE_VBoxBldProg_INCS               += \
@@ -5057,6 +5138,17 @@ TEMPLATE_VBoxBldProg_LIBPATH            += \
 	/usr/lib \
 	/usr/X11R6/lib \
 	/usr/local/lib
+ else if1of ($(KBUILD_HOST), netbsd)
+TEMPLATE_VBoxBldProg_TOOL                = GXX3
+TEMPLATE_VBoxBldProg_LIBS                = pthread
+TEMPLATE_VBoxBldProg_INCS               += \
+	/usr/include \
+	/usr/X11R7/include \
+	/usr/local/include
+TEMPLATE_VBoxBldProg_LIBPATH            += \
+	/usr/lib \
+	/usr/X11R7/lib \
+	/usr/local/lib
  else ifeq ($(KBUILD_HOST),solaris)
 TEMPLATE_VBoxBldProg_TOOL                = GXX3PLAIN
 TEMPLATE_VBoxBldProg_LIBS                = rt
@@ -5099,6 +5191,10 @@ TEMPLATE_VBoxAdvBldProg_LIBS.linux = \
 	$(TEMPLATE_VBoxAdvBldProg_LIBS) \
 	crypt \
 	$(TEMPLATE_VBoxBldProg_LIBS.linux)
+TEMPLATE_VBoxAdvBldProg_LIBS.netbsd = \
+	$(TEMPLATE_VBoxAdvBldProg_LIBS) \
+	rt \
+	$(TEMPLATE_VBoxBldProg_LIBS.netbsd)
 TEMPLATE_VBoxAdvBldProg_LIBS.solaris = \
 	$(TEMPLATE_VBoxAdvBldProg_LIBS) \
 	contract \
@@ -5182,8 +5278,10 @@ TEMPLATE_VBOXGUESTR3EXE_DEFS     := $(filter-out $(ARCH_BITS_DEFS), $(TEMPLATE_V
 TEMPLATE_VBOXGUESTR3EXE_DEFS.linux := $(TEMPLATE_VBOXR3EXE_DEFS.linux) LOG_USE_C99 RT_WITHOUT_EXEC_ALLOC
 ifeq ($(KBUILD_TARGET),linux) # As few libs as possible on linux.
  TEMPLATE_VBOXGUESTR3EXE_LIBS     = pthread rt m dl
-else if1of ($(KBUILD_TARGET), darwin freebsd netbsd openbsd)
+else if1of ($(KBUILD_TARGET), darwin freebsd openbsd)
  TEMPLATE_VBOXGUESTR3EXE_LIBS     = $(TEMPLATE_VBOXR3EXE_LIBS) iconv
+else ifeq ($(KBUILD_TARGET), netbsd)
+ TEMPLATE_VBOXGUESTR3EXE_LIBS     = pthread
 else ifeq ($(KBUILD_TARGET), solaris)
  TEMPLATE_VBOXGUESTR3EXE_LIBS     = $(TEMPLATE_VBOXR3EXE_LIBS) nsl
 endif
@@ -5410,6 +5508,7 @@ TEMPLATE_VBOXCROGLR3HOSTDLL_DEFS.solaris     = SunOS=1 _GNU_SOURCE #GLEXT_64_TYP
 TEMPLATE_VBOXCROGLR3HOSTDLL_DEFS.darwin      = DARWIN=1 GL_GLEXT_LEGACY _GNU_SOURCE VBOX_WITH_COCOA_QT
 TEMPLATE_VBOXCROGLR3HOSTDLL_LDFLAGS.darwin   = -framework AppKit
 TEMPLATE_VBOXCROGLR3HOSTDLL_DEFS.freebsd     = FreeBSD=1 _GNU_SOURCE
+TEMPLATE_VBOXCROGLR3HOSTDLL_DEFS.netbsd      = NetBSD=1 _GNU_SOURCE
 TEMPLATE_VBOXCROGLR3HOSTDLL_INCS             = $(VBOX_PATH_CROGL_INCLUDE) $(VBOX_PATH_CROGL_GENFILES)
 TEMPLATE_VBOXCROGLR3HOSTDLL_SDKS.darwin      = DARWIN-OPENGL
 TEMPLATE_VBOXCROGLR3HOSTDLL_LDFLAGS.darwin  += \
@@ -5438,7 +5537,9 @@ TEMPLATE_VBOXCROGLR3GUESTDLL_DEFS.linux       = Linux=1 _GNU_SOURCE
 TEMPLATE_VBOXCROGLR3GUESTDLL_DEFS.solaris     = SunOS=1 _GNU_SOURCE #GLEXT_64_TYPES_DEFINED
 TEMPLATE_VBOXCROGLR3GUESTDLL_DEFS.darwin      = DARWIN=1 GL_GLEXT_LEGACY _GNU_SOURCE VBOX_WITH_COCOA_QT
 TEMPLATE_VBOXCROGLR3GUESTDLL_LDFLAGS.darwin   = -framework AppKit
+TEMPLATE_VBOXCROGLR3GUESTDLL_LDFLAGS.netbsd   = -Wl,-rpath,/usr/X11R7/lib
 TEMPLATE_VBOXCROGLR3GUESTDLL_DEFS.freebsd     = FreeBSD=1 _GNU_SOURCE
+TEMPLATE_VBOXCROGLR3GUESTDLL_DEFS.netbsd      = NetBSD=1 _GNU_SOURCE
 TEMPLATE_VBOXCROGLR3GUESTDLL_INCS             = $(VBOX_PATH_CROGL_INCLUDE) $(VBOX_PATH_CROGL_GENFILES)
 TEMPLATE_VBOXCROGLR3GUESTDLL_SDKS.darwin      = DARWIN-OPENGL
 TEMPLATE_VBOXCROGLR3GUESTDLL_LDFLAGS.darwin  += \
diff --git include/VBox/VBoxGuest.h include/VBox/VBoxGuest.h
index 9c025eb..4ecf135 100644
--- include/VBox/VBoxGuest.h
+++ include/VBox/VBoxGuest.h
@@ -185,7 +185,7 @@ typedef const VBGLBIGREQ *PCVBGLBIGREQ;
 # define VBOXGUEST_IOCTL_CODE_FAST_(Function)       (0x56420000 | (Function))
 # define VBOXGUEST_IOCTL_STRIP_SIZE(Code)           (Code)
 
-#elif defined(RT_OS_FREEBSD) /** @todo r=bird: Please do it like SUPDRVIOC to keep it as similar as possible. */
+#elif defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD) /** @todo r=bird: Please do it like SUPDRVIOC to keep it as similar as possible. */
 # include <sys/ioccom.h>
 
 # define VBOXGUEST_IOCTL_CODE_(Function, Size)      _IOWR('V', (Function), VBGLBIGREQ)
@@ -508,7 +508,7 @@ typedef VBOXGUESTOS2IDCCONNECT *PVBOXGUESTOS2IDCCONNECT;
 
 #endif /* RT_OS_OS2 */
 
-#if defined(RT_OS_LINUX) || defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD)
+#if defined(RT_OS_LINUX) || defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD)
 
 /* Private IOCtls between user space and the kernel video driver.  DRM private
  * IOCtls always have the type 'd' and a number between 0x40 and 0x99 (0x9F?) */
@@ -528,7 +528,7 @@ typedef VBOXGUESTOS2IDCCONNECT *PVBOXGUESTOS2IDCCONNECT;
 # define DRM_IOCTL_VBOX_ENABLE_HGSMI     VBOX_DRM_IOCTL(ENABLE_HGSMI)
 # define VBOXVIDEO_IOCTL_ENABLE_HGSMI    _IO('d', DRM_IOCTL_VBOX_ENABLE_HGSMI)
 
-#endif /* RT_OS_LINUX || RT_OS_SOLARIS || RT_OS_FREEBSD */
+#endif /* RT_OS_LINUX || RT_OS_SOLARIS || RT_OS_FREEBSD || RT_OS_NETBSD */
 
 /** @} */
 #endif /* !defined(IN_RC) && !defined(IN_RING0_AGNOSTIC) && !defined(IPRT_NO_CRT) */
diff --git include/iprt/alloca.h include/iprt/alloca.h
index c47771c..c9ce7d1 100644
--- include/iprt/alloca.h
+++ include/iprt/alloca.h
@@ -41,10 +41,11 @@
  && (defined(RT_OS_DARWIN) || defined(RT_OS_LINUX) || defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD))
 /* ASSUMES GNU C */
 # define alloca(cb) __builtin_alloca(cb)
-
+#elif defined(IN_RING0) && defined(RT_OS_NETBSD)
+# include <lib/libkern/libkern.h>
 #else
 # include <stdlib.h>
-# if !defined(RT_OS_DARWIN) && !defined(RT_OS_FREEBSD)
+# if !defined(RT_OS_DARWIN) && !defined(RT_OS_FREEBSD) && !defined(RT_OS_NETBSD)
 #  include <malloc.h>
 # endif
 # ifdef RT_OS_SOLARIS
diff --git include/iprt/errno.h include/iprt/errno.h
index ee57065..fbad6d9 100644
--- include/iprt/errno.h
+++ include/iprt/errno.h
@@ -34,6 +34,8 @@
 #  include <linux/errno.h>
 # elif defined(RT_OS_FREEBSD) && defined(_KERNEL)
 #  include <sys/errno.h>
+# elif defined(RT_OS_NETBSD) && defined(_KERNEL)
+#  include <sys/errno.h>
 # else
 #  include <errno.h>
 # endif
diff --git include/iprt/stdarg.h include/iprt/stdarg.h
index 4b93fb0..61b2820 100644
--- include/iprt/stdarg.h
+++ include/iprt/stdarg.h
@@ -33,6 +33,8 @@
 # include <iprt/cdefs.h>
 # if defined(RT_OS_FREEBSD) && defined(_KERNEL)
 #  include <machine/stdarg.h>
+# elif defined(RT_OS_NETBSD) && defined(_KERNEL)
+#  include <sys/stdarg.h>
 # elif defined(RT_OS_SOLARIS) && defined(_KERNEL) && defined(__GNUC__)
 #  include <stdarg.h>
 #  if __GNUC__ >= 4 /* System headers refers to __builtin_stdarg_start. */
diff --git include/iprt/stdint.h include/iprt/stdint.h
index ae94d66..c8c9551 100644
--- include/iprt/stdint.h
+++ include/iprt/stdint.h
@@ -34,6 +34,7 @@
  */
 #if !(defined(RT_OS_LINUX) && defined(__KERNEL__))  \
   && !(defined(RT_OS_FREEBSD) && defined(_KERNEL)) \
+  && !(defined(RT_OS_NETBSD) && defined(_KERNEL)) \
   && !defined(_MSC_VER) \
   && !defined(__IBMC__) \
   && !defined(__IBMCPP__) \
@@ -72,6 +73,16 @@
 # endif
 # include <sys/stdint.h>
 
+#elif defined(RT_OS_NETBSD) && defined(_KERNEL)
+
+# ifndef __STDC_CONSTANT_MACROS
+#  define __STDC_CONSTANT_MACROS
+# endif
+# ifndef __STDC_LIMIT_MACROS
+#  define __STDC_LIMIT_MACROS
+# endif
+# include <sys/stdint.h>
+
 #else /* No system stdint.h */
 
 /*
diff --git include/iprt/string.h include/iprt/string.h
index 22a4097..c0a7299 100644
--- include/iprt/string.h
+++ include/iprt/string.h
@@ -83,6 +83,12 @@
 # undef ffs
 # undef strpbrk
 
+#elif defined(RT_OS_NETBSD) && defined(_KERNEL)
+
+  RT_C_DECLS_BEGIN
+# include <lib/libkern/libkern.h>
+  RT_C_DECLS_END
+
 #else
 # include <string.h>
 #endif
diff --git include/iprt/time.h include/iprt/time.h
index a0021ba..9d4cbfd 100644
--- include/iprt/time.h
+++ include/iprt/time.h
@@ -330,7 +330,7 @@ DECLINLINE(PRTTIMESPEC) RTTimeSpecSubSeconds(PRTTIMESPEC pTime, int64_t i64Secon
 
 
 /* PORTME: Add struct timeval guard macro here. */
-#if defined(RTTIME_INCL_TIMEVAL) || defined(_STRUCT_TIMEVAL) || defined(_SYS__TIMEVAL_H_) || defined(_SYS_TIME_H) || defined(_TIMEVAL) || defined(_LINUX_TIME_H)
+#if defined(RTTIME_INCL_TIMEVAL) || defined(_STRUCT_TIMEVAL) || defined(_SYS__TIMEVAL_H_) || defined(_SYS_TIME_H) || defined(_TIMEVAL) || defined(_LINUX_TIME_H) || defined(_SYS_TIME_H_)
 /**
  * Gets the time as POSIX timeval.
  *
diff --git include/iprt/types.h include/iprt/types.h
index 52ddeef..b7bbfb3 100644
--- include/iprt/types.h
+++ include/iprt/types.h
@@ -88,6 +88,10 @@ RT_C_DECLS_END
 #  define _INTPTR_T_DECLARED
 #  include <sys/types.h>
 
+# elif defined(RT_OS_NETBSD) && defined(_KERNEL)
+
+#  include <sys/types.h>
+
 # elif defined(RT_OS_LINUX) && defined(__KERNEL__)
     /*
      * Kludge for the linux kernel:
@@ -207,6 +211,9 @@ typedef uint8_t bool;
 #   ifndef __bool_true_false_are_defined
 typedef _Bool bool;
 #   endif
+#  elif defined(RT_OS_NETBSD)
+#    undef bool
+typedef _Bool bool;
 #  else
 #   if (defined(RT_OS_DARWIN) || defined(RT_OS_HAIKU)) && (defined(_STDBOOL_H) || defined(__STDBOOL_H))
 #    undef bool
diff --git src/VBox/Additions/Makefile.kmk src/VBox/Additions/Makefile.kmk
index 413408a..5fb853c 100644
--- src/VBox/Additions/Makefile.kmk
+++ src/VBox/Additions/Makefile.kmk
@@ -73,6 +73,9 @@ ifndef VBOX_ONLY_TESTSUITE
  ifeq ($(KBUILD_TARGET),haiku)
   include $(PATH_SUB_CURRENT)/haiku/Makefile.kmk
  endif
+ ifeq ($(KBUILD_TARGET),netbsd)
+  include $(PATH_SUB_CURRENT)/netbsd/Makefile.kmk
+ endif
 
  ifeq ($(KBUILD_TARGET),linux)
   INSTALLS += LnxAddIso-scripts
diff --git src/VBox/Additions/common/VBoxGuest/Makefile.kmk src/VBox/Additions/common/VBoxGuest/Makefile.kmk
index 1ae3c47..fe775ff 100644
--- src/VBox/Additions/common/VBoxGuest/Makefile.kmk
+++ src/VBox/Additions/common/VBoxGuest/Makefile.kmk
@@ -19,7 +19,7 @@ SUB_DEPTH = ../../../../..
 include $(KBUILD_PATH)/subheader.kmk
 
 
-if1of ($(KBUILD_TARGET), darwin freebsd haiku $(if $(defined VBOX_WITH_ADDITION_DRIVERS),linux,) os2 solaris win)
+if1of ($(KBUILD_TARGET), darwin freebsd haiku $(if $(defined VBOX_WITH_ADDITION_DRIVERS),linux,) netbsd os2 solaris win)
  #
  # VBoxGuest - The Guest Additions Driver.
  #
@@ -28,6 +28,7 @@ if1of ($(KBUILD_TARGET), darwin freebsd haiku $(if $(defined VBOX_WITH_ADDITION_
  VBoxGuest_NAME.freebsd  = vboxguest
  VBoxGuest_NAME.haiku    = vboxguest
  VBoxGuest_NAME.linux    = vboxguest
+ VBoxGuest_NAME.netbsd  = vboxguest
  VBoxGuest_NAME.solaris  = vboxguest
  VBoxGuest_INST.darwin   = $(INST_ADDITIONS)VBoxGuest.kext/Contents/MacOS/
  ifdef VBOX_SIGN_ADDITIONS # See Additions/WINNT/Makefile.kmk?
@@ -53,10 +54,12 @@ if1of ($(KBUILD_TARGET), darwin freebsd haiku $(if $(defined VBOX_WITH_ADDITION_
  VBoxGuest_DEPS.linux   += $(VBOX_SVN_REV_HEADER)
  VBoxGuest_DEPS.haiku   += $(VBOX_SVN_REV_HEADER)
  VBoxGuest_DEPS.freebsd += $(VBOX_SVN_REV_HEADER)
+ VBoxGuest_DEPS.netbsd  += $(VBOX_SVN_REV_HEADER)
  VBoxGuest_DEPS.darwin  += $(VBOX_SVN_REV_HEADER)
  VBoxGuest_DEFS          = VBGL_VBOXGUEST VBOX_WITH_HGCM
  VBoxGuest_INCS          = .
  VBoxGuest_INCS.freebsd  = $(VBoxGuest_0_OUTDIR) $(PATH_STAGE)/gen-sys-hdrs
+ VBoxGuest_INCS.netbsd   = $(VBoxGuest_0_OUTDIR)
  VBoxGuest_INCS.linux    = ../../../Runtime/r0drv/linux
  ifeq ($(KBUILD_HOST),solaris)
   VBoxGuest_LDFLAGS.solaris         += -N misc/ctf
@@ -79,7 +82,7 @@ if1of ($(KBUILD_TARGET), darwin freebsd haiku $(if $(defined VBOX_WITH_ADDITION_
     VBoxGuest.cpp_SDKS   = $(VBOX_WINDDK_GST_WLH)
    endif
   endif # win
-  ifn1of ($(KBUILD_TARGET), linux freebsd solaris haiku)
+  ifn1of ($(KBUILD_TARGET), linux freebsd solaris haiku netbsd)
    VBoxGuest_SOURCES    = VBoxGuest-$(KBUILD_TARGET).cpp
   else
    VBoxGuest_SOURCES    = VBoxGuest-$(KBUILD_TARGET).c
